# python简明教程: 3. 控制流




本文内容基本上翻译自[http://cheat.sh/python/:learn)](http://cheat.sh/python/:learn)

**非原创, 非原创, 非原创!!!**

感谢原文社区作者

```python
####################################################
#  3. 控制流
####################################################

# 定义变量
some_var = 5

# 这是if语句，注意缩进，在python里缩进非常重要！
# 结果是打印 "some_var is smaller than 10"
if some_var > 10:
    print "some_var is totally bigger than 10."
elif some_var < 10:  # elif 分支是可选的
    print "some_var is smaller than 10."
else:  # 这也是可选的
    print "some_var is indeed 10."

"""
用for去遍历list
打印结果:
    dog is a mammal
    cat is a mammal
    mouse is a mammal
"""
for animal in ["dog", "cat", "mouse"]:
    # 可以用{0}语法去格式化打印，参考之前的教程
    print "{0} is a mammal".format(animal)

"""
"range(number)" 返回1个列表，列表里包含一组数字
从0到number,不包含number
打印:
    0
    1
    2
    3
"""
for i in range(4):
    print i

"""
"range(lower, upper)" 返回1个列表，列表里包含一组数字
范围从lower到upper
prints:
    4
    5
    6
    7
"""
for i in range(4, 8):
    print i

"""
While会一直循环直到条件不再满足为止
prints:
    0
    1
    2
    3
"""
x = 0
while x < 4:
    print x
    x += 1  # x = x + 1 的简写

# try/except 代码库(block)用来处理异常

# 适用于Python 2.6及以上版本:
try:
    # 使用"raise"来抛出异常
    raise IndexError("This is an index error")
except IndexError as e:
    pass  # Pass就是啥都不做.一般情况下，你会在这里做异常的恢复
except (TypeError, NameError):
    pass  # 如果需要的话可以一次性处理多个异常
else:  # else分支是可选的.必须出现在所有的except分支之后
    print "All good!"  # 当且仅当try代码块中没有抛出任何异常时才会运行
finally:  # 最后一定会执行
    print "We can clean up resources here"

# 除了使用try/finally之外，我们可以使用 with 语句来进行适当的简化
with open("myfile.txt") as f:
    for line in f:
        print line

```




原始封面

![课程图片](https://images.unsplash.com/photo-1581090604093-b89d92ae3bc0?w=300)


